
//-----------------------Header-----------------------------------------------------------

#include <avr/io.h>
#include <lcd.h>


//-----------------------Variablen--------------------------------------------------------





//Datum
unsigned char week_day;
unsigned char day;
unsigned char month;
unsigned int year;

//Zeit
unsigned int millisecond;
unsigned char second;
unsigned char minute;
unsigned char hour;
unsigned char timezone;

//Speicherbereich fr DCF-Pegel
unsigned char dataPC;
unsigned char dcfstatus;

//Pegel-Auswertung
unsigned int counter_high;
unsigned int counter_low;
unsigned char bit_number;

//dcf_Datum
unsigned char dcf_week_day;
unsigned char dcf_day;
unsigned char dcf_month;
unsigned char dcf_year;
unsigned char dcf_date_parity;

//dcf_Zeit
unsigned char dcf_second;
unsigned char dcf_minute;
unsigned char dcf_minute_parity;
unsigned char dcf_hour;
unsigned char dcf_hour_parity;
unsigned char dcf_timezone;

//Schaltjahr
unsigned char leapyear;

//-----------------------------------------------------------------------------------------
//-----------------------LCD-Initialisierung-----------------------------------------------
//-----------------------------------------------------------------------------------------

void lcd_anzeige (void)
{
               //LCD Hintergrundbeleuchtung ein
	
	lcd_text (1, 3,"C");             //Statischer Text wird positioniert
	lcd_text (1,13,":");
    lcd_text (1,10,":");
//    lcd_text (2, 0,"  ");             //Wochentag
//	lcd_text (2,11,".");
 //   lcd_text (2,8,".");
    lcd_text (1,0,tempvorzeichen);
	lcd_text (1,6,dcfstatus);

	lcd_zahl(1, 1, adctemp,2);        //Variablen werden eingepflegt und positioniert
    lcd_zahl (1, 14, second, 2);
    lcd_zahl (1, 11, minute, 2);
    lcd_zahl (1, 8, hour, 2);
//	lcd_zahl (2, 6, day, 2);
//	lcd_zahl (2, 9, month, 2);
//	lcd_zahl (2, 12, year, 4);
	lcd_zahl (2, 0,dataPC,1);
    lcd_zahl (2, 2,counter_high,4);
    lcd_zahl (2, 7,counter_low,4);
	lcd_zahl (2,12,bit_number,3);
}

//----------------------Reset-Funktionen---------------------------------------------------

void counter_reset(void)
{
	counter_high=0;
	counter_low=0;
	bit_number=0;
}

void dcf_date_reset(void)
{
	dcf_week_day=0;
	dcf_day=0;
	dcf_month=0;
	dcf_year=0;
	dcf_date_parity=0;
}

void dcf_time_reset(void)
{
	dcf_minute=0;
	dcf_minute_parity=0;
	dcf_hour=0;
	dcf_hour_parity=0;
	dcf_timezone=0;
}

//------------------------Berechnung Schaltjahr-----------------------------------

void leap_year(void)
{
	if(year%4==0 && year%100!=0)
	{
		leapyear=1;	//Schaltjahr, da durch 4 teilbar aber nicht durch 100
	}
	else
	{
		if(year%4!=0)
		{
			leapyear=0;//Kein Schaltjahr, da nicht durch 4 teilbar
		}
		else
		{
			if(year%400==0)
			{
				leapyear=1;//Schaltjahre, da durch 400 teilbar
			}
			else
			{
				leapyear=0;//Kein Schaltjahr, da durch 100 teilbar aber nicht durch 400
			}
		}
	}
}


//--------------------------DCF-Synchronisation-----------------------------------------

//Low-Pegel mu fr 1700-1900ms anliegen
//Danach mu ein High-Pegel folgen

void dcf_sync(void)
{
    lcd_anzeige();

	//LCD-Ausgabe: Synchronisation luft gerade
	dcfstatus="?";

	if(!(dataPC & (1<<PINB0)))  //Ist das gesendete DCF77 Signal 0?
	{
		if(counter_low>=1750 && counter_low<=1950)
		{
			//LCD-Ausgabe: Synchronisation erfolgreich
			dcfstatus="!";

			counter_reset();
			dcf_date_reset();
			dcf_time_reset();

		}
		else
		{
			counter_low=0;
			dcf_sync();
		}
	}
	else
	{
		dcf_sync();
	}
}

//-----------------------------DCF-Auswertung-----------------------------------------------

void dcf_0(void)
{
	switch(bit_number)
	{
		case 0: ;break;	//Start einer neuen Minuten, mu immer 0 sein
		case 1: ;break;	//Wetterdaten
		case 2: ;break;	//Wetterdaten
		case 3: ;break;	//Wetterdaten
		case 4: ;break;	//Wetterdaten
		case 5: ;break;	//Wetterdaten
		case 6: ;break;	//Wetterdaten
		case 7: ;break;	//Wetterdaten
		case 8: ;break;	//Wetterdaten
		case 9: ;break;	//Wetterdaten
		case 10: ;break;	//Wetterdaten
		case 11: ;break;	//Wetterdaten
		case 12: ;break;	//Wetterdaten
		case 13: ;break;	//Wetterdaten
		case 14: ;break;	//Wetterdaten
		case 15: ;break;	//Rufbit fr PTB
		case 16: ;break; //Keine nderung der Zeitzone
		case 17: ;break;	//Zeitzone: dcf_timezone=dcf_timezone
		case 18: dcf_timezone+=1;break;	//Zeitzone: 
		case 19: ;break;	//keine Schaltsekunde
		case 20: dcf_sync();break;	//Beginn der Zeitinformation (immer 1)
		case 21: ;break;
		case 22: ;break;
		case 23: ;break;
		case 24: ;break;
		case 25: ;break;
		case 26: ;break;
		case 27: ;break;
		case 28: ;break;	//Paritt: Minute
		case 29: ;break;
		case 30: ;break;
		case 31: ;break;
		case 32: ;break;
		case 33: ;break;
		case 34: ;break;
		case 35: ;break;	//Paritt: Stunde
		case 36: ;break;
		case 37: ;break;
		case 38: ;break;
		case 39: ;break;
		case 40: ;break;
		case 41: ;break;
		case 42: ;break;
		case 43: ;break;
		case 44: ;break;
		case 45: ;break;
		case 46: ;break;
		case 47: ;break;
		case 48: ;break;
		case 49: ;break;
		case 50: ;break;
		case 51: ;break;
		case 52: ;break;
		case 53: ;break;
		case 54: ;break;
		case 55: ;break;
		case 56: ;break;
		case 57: ;break;
		case 58: ;break;	//Paritt: Datum
		case 59: dcf_sync();break;	//keine Absenkung --> neue Minute
		default: dcf_sync();break;
	}
}

void dcf_1(void)
{
	switch(bit_number)
	{
		case 0: dcf_sync();break;	//Start einer neuen Minute, mu immer 0 sein
		case 1: ;break;	//Wetterdaten
		case 2: ;break;	//Wetterdaten
		case 3: ;break;	//Wetterdaten
		case 4: ;break;	//Wetterdaten
		case 5: ;break;	//Wetterdaten
		case 6: ;break;	//Wetterdaten
		case 7: ;break;	//Wetterdaten
		case 8: ;break;	//Wetterdaten
		case 9: ;break;	//Wetterdaten
		case 10: ;break;	//Wetterdaten
		case 11: ;break;	//Wetterdaten
		case 12: ;break;	//Wetterdaten
		case 13: ;break;	//Wetterdaten
		case 14: ;break;	//Wetterdaten
		case 15: ;break;	//Rufbit fr PTB
		case 16: ;break; //Am Ende dieser Stunde wird auf MEZ/MESZ umgestellt
		case 17: dcf_timezone+=1;break;	//Zeitzone: 
		case 18: ;break;	//Zeitzone: dcf_timezone=dcf_timezone
		case 19: ;break;	//Am Ende dieser Stunde wird eine Schaltsekunde eingefgt.
		case 20: ;break;	//Beginn der Zeitinformation (immer 1)
		case 21: dcf_minute+=1;dcf_minute_parity+=1;break;
		case 22: dcf_minute+=2;dcf_minute_parity+=1;break;
		case 23: dcf_minute+=4;dcf_minute_parity+=1;break;
		case 24: dcf_minute+=8;dcf_minute_parity+=1;break;
		case 25: dcf_minute+=10;dcf_minute_parity+=1;break;
		case 26: dcf_minute+=20;dcf_minute_parity+=1;break;
		case 27: dcf_minute+=40;dcf_minute_parity+=1;break;
		case 28: dcf_minute_parity+=1;break;	//Paritt: Minute
		case 29: dcf_hour+=1;dcf_hour_parity+=1;break;
		case 30: dcf_hour+=2;dcf_hour_parity+=1;break;
		case 31: dcf_hour+=4;dcf_hour_parity+=1;break;
		case 32: dcf_hour+=8;dcf_hour_parity+=1;break;
		case 33: dcf_hour+=10;dcf_hour_parity+=1;break;
		case 34: dcf_hour+=20;dcf_hour_parity+=1;break;
		case 35: dcf_hour_parity+=1;break;	//Paritt: Stunde
		case 36: dcf_day+=1;dcf_date_parity+=1;break;
		case 37: dcf_day+=2;dcf_date_parity+=1;break;
		case 38: dcf_day+=4;dcf_date_parity+=1;break;
		case 39: dcf_day+=8;dcf_date_parity+=1;break;
		case 40: dcf_day+=10;dcf_date_parity+=1;break;
		case 41: dcf_day+=20;dcf_date_parity+=1;break;
		case 42: dcf_week_day+=1;dcf_date_parity+=1;break;
		case 43: dcf_week_day+=2;dcf_date_parity+=1;break;
		case 44: dcf_week_day+=4;dcf_date_parity+=1;break;
		case 45: dcf_month+=1;dcf_date_parity+=1;break;
		case 46: dcf_month+=2;dcf_date_parity+=1;break;
		case 47: dcf_month+=4;dcf_date_parity+=1;break;
		case 48: dcf_month+=8;dcf_date_parity+=1;break;
		case 49: dcf_month+=10;dcf_date_parity+=1;break;
		case 50: dcf_year+=1;dcf_date_parity+=1;break;
		case 51: dcf_year+=2;dcf_date_parity+=1;break;
		case 52: dcf_year+=4;dcf_date_parity+=1;break;
		case 53: dcf_year+=8;dcf_date_parity+=1;break;
		case 54: dcf_year+=10;dcf_date_parity+=1;break;
		case 55: dcf_year+=20;dcf_date_parity+=1;break;
		case 56: dcf_year+=40;dcf_date_parity+=1;break;
		case 57: dcf_year+=80;dcf_date_parity+=1;break;
		case 58: dcf_date_parity+=1;break;	//Paritt: Datum
		case 59: dcf_sync();break;	//keine Absenkung --> neue Minute
		default: dcf_sync();break;
	}
}

//-----------------------------------------------------------------------------------------
//--------------------Interrupt Service Routine--------------------------------------------
//-----------------------------------------------------------------------------------------
//Der Compare Interrupt Handler wird aufgerufen, wenn TCNT0 = OCR0 = 173-1 ist (250 Schritte), d.h. genau alle 1 ms

ISR (TIMER0_COMP_vect)
{
	millisecond++;	//Counter fr die Millisekunden
	dataPC = PINB;	//Der aktuelle Pegel vom DCF-Modul wird eingelesen und in dataPC den anderen Funktionen zur Verfgung gestellt
	counter_high++;	//Counter fr die Bit-Auswertung (Dauer des High-Pegels), Rcksetzen mu in den Funktionen geschehen
	counter_low++;	//Counter fr die Bit-Auswertung (Dauer des Low-Pegels), Rcksetzen mu in den Funktionen geschehen
	if(millisecond==1000)	//"selbstlaufende" Uhr
	{
		second++;
		millisecond=0;
		if(second==60)
		{
			
			minute++;
			second=0;
		}
		if(minute==60)
		{
			hour++;
			minute=0;
		}
		if(hour==24)
		{
			day++;
			week_day++;
			hour=0;
		}
		if(week_day==8)
		{
			week_day=1;
		}
		
		switch(day)
		{
			case 29:	//Tag 28
			{
				leap_year();
				if(month==2 && leapyear==0)
				{
					month++;
					day=1;
				}
			}
			break;

			case 30:	//Tag 29
			{
				leap_year();
				if(month==2 && leapyear==1)
				{
					month++;
					day=1;
				}
			}
			break;

			case 31:	//Tag 30
			{
				if(month==4 || month==6 || month==9 || month==11)
				{
					month++;
					day=1;
				}
			}
			break;

			case 32:	//Tag 31
			{
				if(month==1 || month==3 || month==5 || month==7|| month==8 || month==10 || month==12)
				{
					month++;
					day=1;
				}
			}
			break;

			default: ;break;
		}
		if(month==13)
		{
			year++;
			month=1;
		}
	}
}

//---------Zusammenfhrung der internen Daten und der DCF-Daten--------------------

void match_date(void)
{
	week_day=dcf_week_day;
	day=dcf_day;
	month=dcf_month;
	year=2000+dcf_year;
}

void match_time(void)
{
	millisecond=0;
	second=0;
	minute=dcf_minute;
	hour=dcf_hour;
	timezone=dcf_timezone;
}


//-----------------------DCF-Pegelauswertung----------------------------------------

void level_analysis(void)
{
	if(dataPC & (1<<PINB0))     //vorher:if(!(dataPC & (1<<PINB0))) //Falls das gesendete DCF77 Signal 0 ist,dann... 
	{

		if(counter_high>=60 && counter_high<=140)	//logisch 0
		{
			dcf_0();
			bit_number++;
			dcf_second++;
			counter_high=0;
			counter_low=0;		
		}
		else
		{
			if(counter_high>=160 && counter_high<=240)	//logisch 1
			{
				dcf_1();
				bit_number++;
				counter_high=0;
				counter_low=0;
			}
			else
			{
				counter_high=0;	
			}
		}
	}
	else
	{
		if(counter_low>=1750 && counter_low<=1950)
		{
			if(bit_number==59 && dcf_minute_parity%2==0 && dcf_hour_parity%2==0 && dcf_date_parity%2==0)
			{
				bit_number=0;
				match_date();
				match_time();
			}
			else
			{
				dcf_date_reset();
				dcf_time_reset();
				counter_low=0;
				dcf_sync();	
			}
			counter_low=0;
			dcf_date_reset();
			dcf_time_reset();	
		}
	}
}

//-----------------------------------------------------------------------------------------
//-----------------------Hauptprogramm-----------------------------------------------------
//-----------------------------------------------------------------------------------------

int main (void)
{
 //DDRB &= ~(1<<PB0);	//PB0 Eingang (0)
 DDRB = 0b11111110;     //Hat sich als besser herausgestellt
 PORTB |= (1<<PB0);	//PB0 Pull-Up gesetzt (1)
 
 lcd_initialisieren();
 lcd_led(1);      

 
 TCCR0 = (1<<WGM01) | (1<<CS00) | (1<<CS01);	//CTC Modus (1), Prescaler 64 (1) (1)
 OCR0 = 173-1; //((16000000/64)/1000) = 250 //Fr interne Uhr an 11,059 MHz angepasst

 TIMSK |= (1<<OCIE0);
 sei();	//Global Interrupts aktivieren
 
 dcf_sync();
while (1)
{
 
 lcd_anzeige();             //Die einzelnen Programme werden aufgerufen
 level_analysis();           //Die einzelnen Programme werden aufgerufen

 }
}





